;
; Interrupt handling routines for the UART
; 
;
; Andreas Tnne
; atoenne@t-online.de
;
; No copyright. This is free software. Thank you for naming the author
;
; Web released version 1.0
;
;***********************************************************************


;*********************   USAGE   ***************************************
;
; NOTE! DO NOT FORGET TO SET THE ENABLE GLOBAL INTERRUPT FLAG
;		USE INSTRUCTION SEI TO START RECEIVING
;
; .include "BufferedUART.asm"
;
; InitializeUARTReading			for enabling interrupt driven RX
;
; UARTReceive					read one byte and buffer it
;								Modifies: NOTHING

;**********************************************************
; enable receive and receive interrupt

.MACRO InitializeUARTReading
	sbi UCR, RXEN
	sbi UCR, RXCIE
	clr UartBufferRead
	clr UartBufferWrite
	ldi UartBufferStatus, UART_BUFFER_EMPTY
.ENDMACRO

; the interrupt handler: read a byte and write it to the buffer

UARTReceive:
	push UartTmp
	in UartTmp, SREG
	push UartTmp
	push ZL
	push ZH
	
	in UartTmp, UDR
	UartBufferWrite UartTmp
	pop ZH
	pop ZL
	pop UartTmp
	out SREG, UartTmp
	pop UartTmp
	reti
